<?php
/**
 * Joomla! 1.5 component Cu3er
 *
 * @version $Id: import.php 2011-04-12 05:17:53 svn $
 * @author Tibor Németh
 * @package Joomla
 * @subpackage Cu3er
 * @license GNU/GPL
 *
 * Cu3er component for Joomla 1.5
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

class Cu3erControllerImport extends JController {

	function display() {
		// setting import view (views/import folder)
		JRequest::setVar('view', 'import');
		
		if($_GET['url'] != '') {
			$model = $this->getModel('import');
			// import //
			$url = urldecode($_GET['url']);
			$name = ($_GET['name'] != '') ? $_GET['name'] : 'CU3ER Slideshow '.date('d-M-Y H:i:s');
			$file['name'] = basename(urldecode($_GET['url']));
			$filepath = JPath::clean(JPATH_COMPONENT.DS.'upload'.DS.$file['name']);
			$cu3er = file_get_contents($url);
			$handle = fopen($filepath, 'w+') or die('can not open.');
			fwrite($handle, $cu3er);
			fclose($handle);
			$model->createEmptySlideshow();
			$config_xml_file = $model->prepareCu3erFilesImport($name, $filepath);
			// instantiating the Cu3erXML class
			$cxml = new Cu3erXML($model->slideshow_id);
			// loading and processing CU3ER config XML file to an array
			$cxml->loadXMLFile($config_xml_file);
			// processing array and generating SQL queries inserting data to DB
			$model->XMLArray2DB($cxml, $name, false);
		} else {
			$model = $this->getModel('setup');
			$view = $this->getView('import','html');
			$view->setModel($model);
			// calling display() method of JController		
			parent::display();
		}
		
		
	}

	function upload() {
		// token checking
		JRequest::checkToken() or jexit('Invalid Token');
		// getting the import model class
		$model = & $this->getModel('import');
		// calling upload method
		$model->upload();
	}

	function save() {
		// token checking
		JRequest::checkToken() or jexit('Invalid Token');

		require_once JPATH_COMPONENT.DS.'lib'.DS.'cu3erxml.class.php';			
		
		// getting import model
		$model = & $this->getModel('import');

		// creating empty slideshow (for slideshow_id)
		$model->createEmptySlideshow();

		// getting the path and the filename of the CU3ER config XML file
		$config_xml_file = $model->prepareCu3erFiles(JRequest::getVar('name'));

		// instantiating the Cu3erXML class		
		$cxml = new Cu3erXML($model->slideshow_id);
		
		// loading and processing CU3ER config XML file to an array
		$cxml->loadXMLFile($config_xml_file);
		// processing array and generating SQL queries inserting data to DB		
		$model->XMLArray2DB($cxml, JRequest::getVar('name'));
	}

	function cancel() {
		$mainframe = &JFactory::getApplication();

		require_once JPATH_COMPONENT.DS.'lib'.DS.'cu3erfile.class.php';
		// cleaning up the temporarly uploaded (and extracted) cu3er files		
		Cu3erFile::deleteAll(JPATH_COMPONENT.DS.'upload'.DS, true);
		// redirecting page to the slideshows list
		$mainframe->redirect('index.php?option=com_cu3er&view=slideshows');
	}

}
