<?php
/**
 * Joomla! 1.5 component Cu3er
 *
 * @version $Id: helper.php 2011-04-12 05:17:53 svn $
 * @author Tibor Németh
 * @package Joomla
 * @subpackage Cu3er
 * @license GNU/GPL
 *
 * Cu3er component for Joomla 1.5
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

/**
 * Cu3er Helper
 *
 * @description class handles the generation of forms for slideshows, defaults and slides
 * @package Joomla
 * @subpackage Cu3er
 * @since 1.5
 */
class Cu3erHelper {

	/**
	 * Slide field HTML element generator method
	 *
	 * @access public
	 * @param string $elm_name name attribute of the HTML element
	 * @param array  $elm array of HTML element's default parameters
	 * @param mixed  $def string/array of HTML element's actual value
	 * @return string string of an HTML element
	 */
	function generateHTML($elm_name, $elm, $def) {
		
		switch ($elm['type']) {

			case 'image' :

				$config =& JComponentHelper::getParams('com_media');				
				// loading mootools' modalbox javascript				
				JHTML::_( 'behavior.modal' );				

				// folder and file vars
				$img_base = JURI::root().($config->get('image_path', 'images/stories'));				
				
				$img_folder = (is_null(parse_url($def, PHP_URL_SCHEME)))?$img_base . DS . 'CU3ER' . DS. $this->slideshow_id.DS:'';
				$img_file = ($def != null)?$img_folder.$def:(JURI::base().DS.'components'.DS.'com_cu3er'.DS.'images'.DS.'dummy.jpg');

				$doc = & JFactory::getDocument();

				// adding mediamanager.js to the head of the document
				$doc->addScript(JURI::base().'components'.DS.'com_cu3er'.DS.'js'.DS.'mediamanager.js');

				// string of the HTML elements (image)				
				$HTML = '<div class="img_thumb">' .
					'<a class="modal" href="'. $img_file .'" rel="{handler: \'image\'}" title="image" onmouseover="javascript:this.href=$(\'image_img_'.$elm_name.'\').getAttribute(\'src\');">' .					
					'<img id="image_img_'.$elm_name.'" src="' . $img_file . '" alt="image" /></a>' .
					'</div><br />' .
					'<input type="hidden" id="joomla_root" value="'.JURI::root().'" />' .
					'<input type="text" value="' . $def .'" name="' . $elm_name .'" id="' .$elm_name .'" />' .
					'<a class="modal" id="browse_lnk" title="Image" ' .
					'onmouseover="javascript:this.href = \''.JURI::root().'administrator/index.php?option=com_cu3er&tmpl=component&view=imagemanager&e_name=PImage&cid=\' + $(\'slideshow_id\').value"' .
					'rel="{handler: \'iframe\', size: {x: 600, y: 420}}"> ' .
					'<button class="button" onclick="javascript:$(\'image_field\').value = \''.$elm_name.'\'">' . JText::_('Browse..') . '</button></a>';
				break;			

			case 'string' :
				
				// simply translating a text
				$HTML = JText::_($def);
				break;

			case 'textarea' :
				
				$HTML = '<textarea name="' . $elm_name .'" cols="50" rows="5">'.$def.'</textarea>';				
				break;
						

			// generating colorpicker HTML element		
			case 'colorpicker' :

				// converting color codes for compatibility reasons
				$style_color = str_replace("0x", "#", $def);

				// calling color picker javascript code generator
				Cu3erHelper::generateColorPickerJS($elm_name, $def);

				// string of color picker's HTML element				
				$HTML = '<div class="cpfield">
					<input id="' . $elm_name . '" name="'. $elm_name .'" type="text" size="16" value="'.strtoupper($def).'" />
					</div>
					<div id="cpicon_' . $elm_name . '" class="cpicon" style="background: '.$style_color.'" ></div>';	
				break;

			default: 

				// option array for JHTML select method
				$arr = array();
			
				// foreach loop to check every value of a parameter
				foreach ($elm['value'] as $key => $value) {
						
					// setting the option array
					$arr[] = JHTML::_('select.option', $value, JText::_((isset($elm['label'])?'COM_CU3ER_'.strtoupper(str_replace(" ", "_", $elm['label'][$key])):$value)));

					// handling naming exception in parameter types 
					if ($elm['type'] != 'checkbox') {
						$type = $elm['type'];
					} else {
						$type = 'radiolist';
					}
					
					// generating JHTML element
					$HTML = JHTML::_('select.' . $type, $arr, $elm_name, null, 'value', 'text', $def);
					
					if ($elm['type'] == 'checkbox') {

						// generating checkboxes from radiolist (hack trick)
						$checkeds = (!is_array($def))?explode(",", $def):$def;					

						foreach ($checkeds as $chk) {						
							$HTML = preg_replace('/\"' . preg_quote($chk). '\"/', '"' . $chk . '" checked="checked"', $HTML);
						}

						$HTML = str_replace(array('radio', $elm_name), array('checkbox', $elm_name . '[]'), $HTML);
					}
				} 
	
				break;
		}

		return $HTML;
	}


	/**
	 * Color Picker Javascript code generator method
	 *
	 * @access public
	 * @param  string $id		unique id of the colorpicker HTML element
	 * @param  string $color	hexadecimal color code
	 * @return string of an HTML element
	 */
	function generateColorPickerJS($id, $color) {

		// colorpicker javascript counter (if there are multiple)
		$num = &$this->num;
		$doc = & JFactory::getDocument();

		// path of moorainbow.js
		$mr_path = JURI::base().'components'.DS.'com_cu3er'.DS.'js'.DS.'moorainbow';

		// if counter is 0		
		if ($num < 1) {
			// adding moorainbow javascript and css files only once			
			$doc->addScript($mr_path.DS.'mootools-more-1.4.0.1.js');
			$doc->addScript($mr_path.DS.'mooRainbow.js');
			$doc->addStyleSheet($mr_path.DS.'mooRainbow.css');
		}

		// converting hexadecimal color codes to RGB values
		$col = Cu3erHelper::hexToRGB($color);

		// moorainbow javascript calling
		$js_str = "window.addEvent('domready', function() {
				var cp_" . $id . " = new MooRainbow('cpicon_" . $id . "', {
					'id': 'cp_" . $id . "',
					'startColor': [{$col['red']},{$col['green']},{$col['blue']}],
					'imgPath' : '" .$mr_path .DS. "images/',								
					'onChange': function(color) {
							$('" . $id . "').value = color.hex;
							$('cpicon_" . $id . "').setStyle('background', color.hex);
						}
					});
				});\n";			
	
		$doc->addScriptDeclaration($js_str);
		$this->num++;

		return true;
	}

	/**
	 * Hexadecimal to RGB color code converter method
	 *
	 * @access public
	 * @param  string $color hexadecimal color code
	 * @return array array of red, green and blue values
	 */
	function hexToRGB($color) {

		// if color code is like '#112233'		
		if ($color[0] == '#') {
			$color = substr($color, 1);
		}

		// if color code is like '0x112233'
		if ($color[0] == '0') {
			$color = substr($color, 2);		
		}

		if (strlen($color) == 6) {
			list($r, $g, $b) = array($color[0].$color[1],
                        		         $color[2].$color[3],
                        		         $color[4].$color[5]);
		} elseif (strlen($color) == 3) {
			list($r, $g, $b) = array($color[0].$color[0], $color[1].$color[1], $color[2].$color[2]);
    		} else {
		        return false;
		}

		return array('red' => hexdec($r), 'green' => hexdec($g), 'blue' => hexdec($b));
	}

	/**
	 * Slideshow name getter method
	 *
	 * @access public
	 * @return string string of slideshow name
	 */
	function getSlideshowName() {
		$model = & JModel::getInstance('Slideshow','Cu3erModel');
		return $model->getData($this->slideshow_id, 'name');	
	}

}
?>
