<?php
/**
 * Joomla! 1.5 component Cu3er
 *
 * @version $Id: view.html.php 2011-04-12 05:17:53 svn $
 * @author Tibor Németh
 * @package Joomla
 * @subpackage Cu3er
 * @license GNU/GPL
 *
 * Cu3er component for Joomla 1.5
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the Cu3er component
 */
class Cu3erViewSlideshow extends JView {

	function display($tpl = null) {
		
		$doc = & JFactory::getDocument();	
		$cid = (JRequest::getInt('cid'))?(JRequest::getInt('cid')):(JRequest::getInt('slideshow_id'));
		
		// generating $preview boolean
		$preview = (JRequest::getInt('preview') > 0);

		jimport('joomla.filesystem.file');
		jimport('joomla.utilities.simplexml');
		
		// if $preview is true $gen_XML is CU3ER-preview.xml, else CU3ER-generated.xml
		$gen_XML = JPATH_COMPONENT_SITE.DS.'slideshows'.DS.$cid.DS.(($preview)?'CU3ER-preview.xml':'CU3ER-generated.xml');

		// reading XML encoded string
		$XML_encoded = (JFile::exists($gen_XML))?JFile::read($gen_XML):null;
		// parsing XML string
		$xml = JFactory::getXMLParser('Simple');
		$xml->loadString($XML_encoded);

		// referencing XML document		
		$xml_doc = &$xml->document;

		// if it's a preview or a published slideshow		
		if ($preview || ($xml_doc->getElementByPath('settings/published') && 
			$xml_doc->getElementByPath('settings/published')->data() == 1)) {

			require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'lib'.DS.'cu3erfile.class.php');
	
			$CU3ER_root = JURI::root().'components'.DS.'com_cu3er';

			// setting slideshow parameters from parsed XML nodes
			$xml_location = ($xml_doc->getElementByPath('settings/xml_location')->data())?$xml_doc->getElementByPath('settings/xml_location')->data():"{$CU3ER_root}/slideshows/{$cid}/CU3ER-config.xml";
			$backgroundType = ($xml_doc->getElementByPath('settings/background/color')->attributes('transparent'))?'transparent':false;		
			$background = $xml_doc->getElementByPath('settings/background/color')->data();
			$folder_images = $xml_doc->getElementByPath('settings/folder_images')->data();
			$folder_fonts = $xml_doc->getElementByPath('settings/folder_fonts')->data();
			$width = $xml_doc->getElementByPath('project_settings/width')->data();
			$height = $xml_doc->getElementByPath('project_settings/height')->data();
			$alt_content = ($xml_doc->getElementByPath('settings/content')->data())?$xml_doc->getElementByPath('settings/content')->data():(JText::_('alt_content'));
		
			// preview=2 parameter in the URL means it's a javascript preview			
			if (JRequest::getInt('preview') > 1) {
				$force_js = 'true';
			} elseif ($preview) {
				$force_js = 'false';
			} else {
				// setting force_js if it's not a preview				
				$force_js = ($xml_doc->getElementByPath('settings/force_js'))?$xml_doc->getElementByPath('settings/force_js')->data():'false';
			}
			
			// stripping http:// 			
			preg_replace('/http\:\/\/(.*?)\//', '/', $CU3ER_root);		

			// JHTML::_('behavior.mootools');

			// adding neccessary js and css files to HTML head (only once)
			Cu3erFile::addJsFile('jquery.js');
			Cu3erFile::addJsFile('swfobject.js');
			Cu3erFile::addJsFile('jquery.cu3er.js');

			// adding more js and css files for displaying javascript version
			if ($force_js != 'false') {
				Cu3erFile::addJsFile('jquery.cu3er.player.js');
				Cu3erFile::addCSSFile('CU3ER.css');
				Cu3erFile::addCSSFile('CU3ERieFix.css', 'IE');
			}

			if ($preview) {
				Cu3erFile::addCSSFile('contentfix.css');
			}

			// setting wmode parameter			
			$wmode = ($backgroundType == 'transparent') ? "transparent" : "color: ".str_replace('0x', '#', $background);

			// URL encoding XML string
			$uenc_XML = urlencode($XML_encoded);

			// setting CU3ER embedder javascript code
			$js_str = <<<EOD
			
				jQuery(document).ready(function($) {					

					var preview = {$preview};

					$('#CU3ER{$cid}').cu3er({
						vars: {
							xml_location: '{$xml_location}',
							xml_encoded: '{$uenc_XML}',
							swf_location: '{$CU3ER_root}/flash/CU3ER.swf',
							width: '{$width}',
							height: '{$height}',
							force_javascript: {$force_js},
							folder_images: '{$folder_images}',
							folder_fonts: '{$folder_fonts}',
						},
						params: {
							wmode: '{$wmode}',
							allowScriptAccess: 'always',
						},
						attributes: {
							name:'CU3ER',
							id:'CU3ER',
						}
					});

					if (preview) {
						parent.document.getElement('iframe').setStyles({'width':{$width},'height':{$height}});
					}
				});
EOD;
			// adding embedder code to the HTML head
			$doc->addScriptDeclaration($js_str);
	
			// assigning variables to the template (tmpl/default.php)
			if(!$preview) {
				$model = & $this->getModel();
				$slides = $model->getSlides($cid);
				foreach($slides as $key=>$value) {
					$image_url = $folder_images . $value['image'];
					$image_alt = $value['seo_img_alt'];
					$heading = $value['heading'];
					$paragraph = $value['paragraph'];
					$caption = $value['caption'];
					$seo_text = $value['seo_text'];
					$slide_link = $value['link'];
					$slide_link_target = $value['target'];
					if ($slide_link_target == '') $slide_link_target = $value['target'];
					$desc_link = $value['dlink'];
					$desc_link_target = $value['dtarget'];
					if ($desc_link_target == '') $desc_link_target = $default['dtarget'];
					if ($slide_link == '') { $slide_link = $value['link']; }
					if ($desc_link == '') { $desc_link = $value['dlink']; }

					$seo_str .= "<li>";
					if ($slide_link != "") {
						$seo_str .= '<a href="'.$slide_link.'" target="'.$slide_link_target.'">' ."\n";
					}
					if (($default['seo_show_image'] == 'yes' && $value['seo_show_image'] != 'no') || $value['seo_show_image'] == 'yes') {
						$seo_str .= "<img src='$image_url' alt='".addslashes($image_alt)."'/>\n"; 
					}
					if ($slide_link != "" && $desc_link != "") {
						$seo_str .= '</a><a href="'.$desc_link.'" target="'.$desc_link_target.'">' ."\n";
					} elseif($desc_link != '') {
						$seo_str .= '<a href="'.$desc_link.'" target="'.$desc_link_target.'">' ."\n";
					}
					if ($default['seo_show_heading'] == 'yes' || $value['seo_show_heading'] == 'yes' && $heading != "") {
						$seo_str .= "<h2>".$heading."</h2>" ."\n"; 
					}
					if ($default['seo_show_paragraph'] == 'yes' || $value['seo_show_paragraph'] == 'yes' && $paragraph != "") {
						$seo_str .= "<p>".$paragraph."</p>" ."\n"; 
					}
					if ($desc_link != "") {
						$seo_str .= "</a>" ."\n";
					}
					if ($slide_link != "" && $desc_link == "") {
						$seo_str .= '</a>' ."\n";
					}  
					if ($default['seo_show_caption'] == 'yes' || $value['seo_show_caption'] == 'yes' && $caption != "") {
						$seo_str .= "<p>".$caption."</p>" ."\n"; 
					}
					if ($seo_text != "") {
						$seo_str .= "<p>".$seo_text."</p>" ."\n"; 
					}
					$seo_str .= "</li>" ."\n";
				}
				$seo_str = '<ul style="position:absolute; left:-50000px;">'.$seo_str.'</ul>';
				$this->assignRef('seo', $seo_str);
			}
			$this->assignRef('alt_content', $alt_content);
			$this->assignRef('slideshow_id', $cid);

			parent::display($tpl);
		
		}
	}

}
?>